<?php
//Obtengo la ruta General de los archivos!
$uri ='../../Classes/core_class/consultasDb.php';

include_once($uri);

class resumen_localizacion_jerarquica extends consultasDb
{

	public function __construct()
	{
		parent::__construct('');
		$this->setDbLink(parent::Conectar());
	}

	public function GetSucursales()
	{
	   $sucursales = new consultasDb('');
	   $sucursales->setConsulta('SELECT LocalizacionJerarquicaID, Descripcion FROM Sucursales');
	   $resultado_sucursales = $sucursales->query();
	   $sucursales_array= array();
	   while($row = $sucursales->fetchArray($resultado_sucursales))
	   {
			array_push($sucursales_array,$row);
	   }
	   
	   return $sucursales_array; 
	}
	
	public function GetOperadoresMoviles()
	{	   
	   $operadores_moviles = new consultasDb('');
	   $operadores_moviles->setConsulta("select * from operadores_moviles");
	   $resultado_operadores_moviles = $operadores_moviles->query();
	   
	   $operadores_moviles_array= array();
	   while($row = $operadores_moviles->fetchArray($resultado_operadores_moviles))
	   {
			array_push($operadores_moviles_array,$row);
	   }	   
	   return $operadores_moviles_array;
	}
	
	public function GetDistritosBySucursalID($parametros)
	{	   
	   $distritos = new consultasDb('');
	   $distritos->setConsulta("CALL get_distritos_by_sucursal_id('".implode(",",json_decode($parametros['sucursales']))."')");
	   $resultado_distritos = $distritos->query();
	   
	   $distritos_array= array();
	   while($row = $distritos->fetchArray($resultado_distritos))
	   {
			array_push($distritos_array,$row);
	   }	   
	   return json_encode($distritos_array);
	}
	
	public function GetZonasByDistritosID($parametros)
	{	   
	   $zonas = new consultasDb('');
	   $zonas->setConsulta("CALL get_zonas_by_distrito_id('".implode(",",json_decode($parametros['distritos']))."')");
	   $resultado_zonas = $zonas->query();
	   
	   $zonas_array= array();
	   while($row = $zonas->fetchArray($resultado_zonas))
	   {
			array_push($zonas_array,$row);
	   }	   
	   return json_encode($zonas_array);
	}
	
	public function GetConfiguraciones($ConfiguracionNombre)
	{
	   $configuraciones = new consultasDb('');
	   $configuraciones->setConsulta("SELECT * FROM configuraciones WHERE ConfiguracionNombre = '".$ConfiguracionNombre."'");
	   $q = $configuraciones->query();
	   $row = $configuraciones->fetchArray($q);
	   $configuraciones->Desconectar();
	   return $row["ConfiguracionValor"];
	}
	
	public function GetSucursalesAsociadasPorOperador($operador_monitor_id)
	{	   
	   $sucursales_asociadas = new consultasDb('');
	   $sucursales_asociadas->setConsulta("SELECT LocalizacionJerarquicaID 
	   									   FROM operadores_monitores_sucursales
										   WHERE OperadorMonitorID = ".$operador_monitor_id);
	   $resultado_sucursales_asociadas = $sucursales_asociadas->query();
	   
	   $sucursales_asociadas_array= array();
	   while($row = $sucursales_asociadas->fetchArray($resultado_sucursales_asociadas))
	   {
			array_push($sucursales_asociadas_array,$row["LocalizacionJerarquicaID"]);
	   }	   
	   return $sucursales_asociadas_array;
	}
	
	public function GetResumenLocalizacionJerarquica($parametros)
	{		
		try
		{			
			$getResumen = new consultasDb("");
			$query ="call get_resumen('".$parametros['fecha_desde']."','"
										.$parametros['fecha_hasta']."','"
									    .implode(",",json_decode($parametros['localizaciones_jerarquicas']))."','"
									    .implode(",",json_decode($parametros['operadores_moviles']))."',"
										.$parametros['ultimo_nivel'].");";

			$getResumen->setConsulta($query);
			$q = $getResumen->query();
			$getResumen->Desconectar();
			$json = '{"aaData":[';
			
			if($q){
				$first = true;
				while($row = $getResumen->fetchArray($q)){
					if($first) {
						$first = false;
					} else {
						$json .= ',';
					}
					if($parametros['ultimo_nivel']=='1'){	
						$json .= '["'.$row["Sucursal_Descripcion"].'","'
						.$row["NroOperadorMovil"].'","'
						.$row["NombreApellido"].'","'
						.$row["CantUnidades"].'","'
						.$row["CantClientes"].'","'
						.$row["CantUc"].'","'
						.$row["total"].'"]';
					}
					
					else if($parametros['ultimo_nivel']=='2'){	
						$json .= '["'.$row["Sucursal_Descripcion"].'","'
						.$row["Distrito_Descripcion"].'","'					
						.$row["NroOperadorMovil"].'","'
						.$row["NombreApellido"].'","'
						.$row["CantUnidades"].'","'
						.$row["CantClientes"].'","'
						.$row["CantUc"].'"]';
					}
					
					else if($parametros['ultimo_nivel']=='3'){	
						$json .= '["'.$row["Sucursal_Descripcion"].'","'
						.$row["Distrito_Descripcion"].'","'					
						.$row["Zona_Descripcion"].'","'
						.$row["NroOperadorMovil"].'","'
						.$row["NombreApellido"].'","'
						.$row["CantUnidades"].'","'
						.$row["CantClientes"].'","'
						.$row["CantUc"].'"]';
					}
				}
				$json .= ']}';
			} else {
				$json .= '[]';
			}
			echo $json;
			//echo '{"aaData":[["04-04-2014","09:35:15","Jose Perez 1","115","Carga"],["03-04-2014","10:35:15","Joe Perez 8","116","Nuevo"]]}';
		} 
		catch (Exception $e) 
		{
			return 'Excepción capturada: '.  $e->getMessage(). "\n";
		}
	}
}
?>